VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "XMLEventLog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Implements EventLog

Private mobjLog As New EventLog
Private mobjDoc As XMLTag

Const TAG_LOG_DOCUMENT = "EVENTLOG"
Const TAG_EVENT_LOG = "LOGEVENT"
Const TAG_TIMESTAMP = "TIMESTAMP"
Const TAG_EVENT_SOURCE = "EVENTSOURCE"
Const TAG_CATEGORY = "CATEGORY"
Const TAG_EVENT_ID = "EVENTID"
Const TAG_USER_NAME = "USERNAME"
Const TAG_COMPUTER_NAME = "COMPUTERNAME"

Private Sub InitXMLDoc()

  Set mobjDoc = New XMLTag
  mobjDoc.Name = TAG_LOG_DOCUMENT
  mobjDoc.Text = "Created by RMTLogLib::XMLEventLog on " & Now

End Sub

Private Sub Class_Terminate()
  
  Enabled = False
  
  Set mobjLog = Nothing
  Set mobjDoc = Nothing

End Sub


' Required Interface Elements - EventLog
Private Property Let EventLog_Enabled(ByVal RHS As Boolean)

  Enabled = RHS

End Property

Private Property Get EventLog_Enabled() As Boolean

  EventLog_Enabled = Enabled

End Property

Private Property Let EventLog_EventSource(ByVal RHS As String)

  EventSource = RHS

End Property

Private Property Get EventLog_EventSource() As String

  EventLog_EventSource = EventSource

End Property

Private Property Let EventLog_LogDestination(ByVal RHS As String)
  
  LogDestination = RHS

End Property

Private Property Get EventLog_LogDestination() As String

  EventLog_LogDestination = LogDestination

End Property

Private Function EventLog_WriteLog(Message As String, EventType As LogEventTypes, EventID As Long) As Boolean

  EventLog_WriteLog = WriteLog(Message, EventType, EventID)

End Function

Private Property Get EventLog_UserName() As String

  EventLog_UserName = UserName

End Property

Private Property Get EventLog_ComputerName() As String

  EventLog_ComputerName = ComputerName

End Property


' Public Interface Elements - XMLEventLog
Public Property Let Enabled(ByVal RHS As Boolean)
  
  If (RHS = False) And (mobjLog.Enabled) Then
    mobjLog.OutputFile.WriteFile mobjDoc.toString()
    Set mobjDoc = Nothing
  End If
  
  If (RHS = True) And (mobjLog.Enabled = False) Then
    InitXMLDoc
  End If
  
  mobjLog.Enabled = RHS
  
End Property
Public Property Get Enabled() As Boolean
  
  Enabled = mobjLog.Enabled

End Property

Public Property Let EventSource(ByVal RHS As String)
  
  mobjLog.EventSource = RHS
  
End Property

Public Property Get EventSource() As String
  
  EventSource = mobjLog.EventSource
  
End Property

Public Property Let LogDestination(ByVal RHS As String)
  
  mobjLog.LogDestination = RHS
  
End Property

Public Property Get LogDestination() As String
  
  LogDestination = mobjLog.LogDestination
  
End Property

Public Function WriteLog(Message As String, EventType As LogEventTypes, EventID As Long) As Boolean

  If mobjLog.Enabled = False Then
    Err.Raise vbObjectError + ERR_WRITELOG_DISABLED, App.Title, "Can't write to log when Enabled = False"
    WriteLog = False
    Exit Function
  End If
  
  With mobjDoc.Children.Add(TAG_EVENT_LOG, Message).Attributes
    .Add TAG_TIMESTAMP, CStr(Now)
    .Add TAG_EVENT_SOURCE, EventSource
    .Add TAG_CATEGORY, CStr(EventType)
    .Add TAG_EVENT_ID, CStr(EventID)
    .Add TAG_USER_NAME, UserName
    .Add TAG_COMPUTER_NAME, ComputerName
  End With
  
  WriteLog = True
  
End Function

Public Property Get UserName() As String

  UserName = mobjLog.UserName

End Property

Public Property Get ComputerName() As String

  ComputerName = mobjLog.ComputerName

End Property

